{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S+,T-,V+,X+,Y+}
{$M 16384,0,655360}
{
Mladez - 34
Pouziva EGAVGA.BGI


Ovladani klavesnici: Numpad/sipky - pohyb kursoru
                     Space leve tlacitko
                     Enter prave tlacitko


q,Q - quit - konec
+/- - uprava delaye v demu
Prave tlacitko - advice - vyhodny tah
}
uses graph,dos,crt;

const NN=10;            {max.strana site}
      _size=30;         {velikost ctverce v pixlech}
      STEP=5;           {po kolika bodech hybat s mysim kurzorem}

var vfield,hfield:array[1..NN+1,1..NN]of boolean; {jednotlive sirky}
    ofield:array[1..NN,1..NN]of integer;          {vlastnictvi poli}
    N:integer;                                    {strana site}
    onturn:integer;                               {kdo jest na rade}
    col,                                          {barva hrace}
    skore:array[0..2] of integer;                 {skore hrace}
    usedAI:array[1..2] of boolean;                {uz hrac uzil advice?}
    againstAI:boolean;                            {hrat proti pocitaci?}
    demo:boolean;                                 {demo?}
    ddelay:integer;                               {prodleva v demo}

function ismouse:boolean;                         {zjisteni a init mysi}
var r:registers;
begin
r.ax:=0;
intr($33,r);
ismouse:=r.ax=$FFFF;
end;

procedure initfield;                              {init hraciho pole}
var i,j:integer;
begin
for i:=1 to N+1 do
 for j:=1 to N do
  begin
   vfield[i,j]:=false;
   hfield[i,j]:=false;
   if i<=N then ofield[i,j]:=0;
  end;
end;

procedure init;                                 {celkovy init}
begin
 randomize;
 if not ismouse then
  begin
   writeln('Mys neni instalovana!!!');
   halt;
  end;
 ddelay:=350;
 col[0]:=black;
 col[1]:=lightblue;
 col[2]:=lightred;
end;

procedure nextplease;                           {predej hru dalsimu hraci}
begin
onturn:=3-onturn;
end;

function iscomplete(x,y:integer):boolean;       {je tento ctverec zaplnen?}
begin
if (x<1)or(x>N)or(y<1)or(y>N)or(ofield[x,y]<>0) then
 iscomplete:=false
else
 iscomplete:=hfield[y,x] and vfield[x,y] and hfield[y+1,x] and vfield[x+1,y];
end;

function completed(x,y:integer):integer;        {kolik sirek lezi okolo ctverce?}
var i:integer;
begin
 if (x<1)or(x>N)or(y<1)or(y>N) then completed:=4 else
 begin
  i:=0;
  if hfield[y,x] then inc(i);
  if vfield[x,y] then inc(i);
  if hfield[y+1,x] then inc(i);
  if vfield[x+1,y] then inc(i);
  completed:=i;
 end;
end;

procedure dispfield;                            {vykresli pole}
var i,j:integer;
begin
for i:=1 to N+1 do
 for j:=1 to N do
  begin
   if i<=N then
    begin
     setcolor(col[ofield[i,j]]);
     setfillstyle(1,col[ofield[i,j]]);
     bar(i*_size+1,j*_size+1,(i+1)*_size-1,(j+1)*_size-1);
    end;
   if vfield[i,j] then setcolor(green) else setcolor(darkgray);
   line(i*_size,j*_size,i*_size,(j+1)*_size);
   if hfield[i,j] then setcolor(green) else setcolor(darkgray);
   line(j*_size,i*_size,(j+1)*_size,i*_size);
  end;
end;

{par zakladnich rutin...}
procedure setmouse(x,y:word);var r:registers;begin r.ax:=4;r.cx:=x;r.dx:=y;intr($33,r);end;
procedure dispmouse;var r:registers;begin r.ax:=1;intr($33,r);end;
procedure hidemouse;var r:registers;begin r.ax:=2;intr($33,r);end;
function lclick:boolean;var r:registers;begin r.ax:=3;intr($33,r);lclick:=(r.bx AND 1<>0)end;
function rclick:boolean;var r:registers;begin r.ax:=3;intr($33,r);rclick:=(r.bx AND 2<>0)end;
function mx:integer;var r:registers;begin r.ax:=3;intr($33,r);mx:=r.cx;end;
function my:integer;var r:registers;begin r.ax:=3;intr($33,r);my:=r.dx;end;
function inttostr(i:integer):string;var x:string;begin str(i,x);inttostr:=x;end;


procedure AIchoose(var a,b,d:integer);                       {zde jest jadro pudla, totiz vyber dobreho tahu}
var por0:array[0..4]of integer;
     {
      tyhle pole slouzi k priorite vyberu poli -
       je to 3,1,0,2 polozenych sirek
        (3 laka k dokonceni, 2 je naopak hloupost, protoze dava
         moznost protivnikovi)
     }

 procedure choosefree(x,y:integer;var a,b,d,p:integer);
  {tato procedura pro zvolene pole vybira nejlepsiho souseda}
 var pp,prefn:integer;
 begin
  pp:=p;prefn:=0;p:=5;

  if (pp<p)and(y=1)and(not hfield[y,x]  ) then begin p:=pp;prefn:=1 end;
  if (pp<p)and(y=N)and(not hfield[y+1,x]) then begin p:=pp;prefn:=2 end;
  if (pp<p)and(x=1)and(not vfield[x,y]  ) then begin p:=pp;prefn:=3 end;
  if (pp<p)and(x=N)and(not vfield[x+1,y]) then begin p:=pp;prefn:=4 end;

  if (y<>1)and(por0[completed(x,y-1)]<p)and(not hfield[y,x]  ) then begin p:=por0[completed(x,y-1)];prefn:=1 end;
  if (y<>N)and(por0[completed(x,y+1)]<p)and(not hfield[y+1,x]) then begin p:=por0[completed(x,y+1)];prefn:=2 end;
  if (x<>1)and(por0[completed(x-1,y)]<p)and(not vfield[x,y]  ) then begin p:=por0[completed(x-1,y)];prefn:=3 end;
  if (x<>N)and(por0[completed(x+1,y)]<p)and(not vfield[x+1,y]) then begin p:=por0[completed(x+1,y)];prefn:=4 end;

  case prefn of
   1:begin a:=y;b:=x;d:=0 end;
   2:begin a:=y+1;b:=x;d:=0 end;
   3:begin a:=x;b:=y;d:=1 end;
   4:begin a:=x+1;b:=y;d:=1 end;
  end;
  if p<pp then p:=pp;
 end;

var aa,bb,dd,pp,x,y,k,p:integer;

begin
por0[0]:=3;por0[1]:=2;por0[2]:=4;por0[3]:=1;por0[4]:=5;

p:=5;                                               {a ted vyber to nejlepsi}
for x:=1 to N do
for y:=1 to N do
 begin
  pp:=por0[completed(x,y)];
  if pp<p then                                      {jinak to ani neam cenu,ze}
   begin
    choosefree(x,y,aa,bb,dd,pp);
    if pp<p then begin a:=aa;b:=bb;d:=dd;p:=pp end;
   end;
 end;
end;

procedure place;                                     {zpracuj zadost o umisteni}
var x,y,dx,dy:integer;
    p:boolean;

procedure compl;                                     {dopln ctverec a body}
begin
  p:=false;
  if iscomplete(x,y) then begin p:=true;inc(skore[onturn]);ofield[x,y]:=onturn end;
  if iscomplete(x-1,y) then begin p:=true;inc(skore[onturn]);ofield[x-1,y]:=onturn end;
  if iscomplete(x+1,y) then begin p:=true;inc(skore[onturn]);ofield[x+1,y]:=onturn end;
  if iscomplete(x,y-1) then begin p:=true;inc(skore[onturn]);ofield[x,y-1]:=onturn end;
  if iscomplete(x,y+1) then begin p:=true;inc(skore[onturn]);ofield[x,y+1]:=onturn end;
  if not p then nextplease;
end;

begin
x:=mx div _size;
y:=my div _size;
dx:=mx mod _size;
dy:=my mod _size;
if (x>N)or(y>N)or(x<1)or(y<1)then exit;
if (dy>dx)and(dy<_size-dx) then if not vfield[x,y] then begin vfield[x,y]:=true;compl;end;
if (dy<dx)and(dy>_size-dx) then if not vfield[x+1,y] then begin vfield[x+1,y]:=true;compl;end;
if (dy<dx)and(dy<_size-dx) then if not hfield[y,x] then begin hfield[y,x]:=true;compl;end;
if (dy>dx)and(dy>_size-dx) then if not hfield[y+1,x] then begin hfield[y+1,x]:=true;compl;end;
end;

procedure place2(a,b,d:integer);        {umisti z aichoose}
var x,y:integer;

procedure compl;
var p:boolean;
begin
  p:=false;
  if iscomplete(x,y) then begin p:=true;inc(skore[onturn]);ofield[x,y]:=onturn end;
  if iscomplete(x-1,y) then begin p:=true;inc(skore[onturn]);ofield[x-1,y]:=onturn end;
  if iscomplete(x+1,y) then begin p:=true;inc(skore[onturn]);ofield[x+1,y]:=onturn end;
  if iscomplete(x,y-1) then begin p:=true;inc(skore[onturn]);ofield[x,y-1]:=onturn end;
  if iscomplete(x,y+1) then begin p:=true;inc(skore[onturn]);ofield[x,y+1]:=onturn end;
  if not p then nextplease;
end;

begin
if d=0 then begin hfield[a,b]:=true;x:=b;y:=a;end
 else begin vfield[a,b]:=true;x:=a;y:=b;end;
compl;
end;


function finished:boolean;                      {uz je konec?}
begin
finished:=N*N=skore[1]+skore[2];
end;

procedure disp;                         {vykresli vsechno}
var i,x,y:integer;
begin
cleardevice;
hidemouse;
dispfield;
x:=mx;y:=my;
ismouse;
setmouse(x,y);
dispmouse;
setcolor(white);outtextxy(0,_size*(NN+2),'Na tahu je hrac c.'+inttostr(onturn));
setcolor(col[1]);outtextxy(0,_size*(NN+2)+15,'Skore hrace c.1:'+inttostr(skore[1]));
setcolor(col[2]);outtextxy(0,_size*(NN+2)+30,'Skore hrace c.2:'+inttostr(skore[2]));
end;


{ted je TOPTEN}
type
    TTT=record jmeno:string;skore:integer end;
    TTREC=array[1..12] of TTT;

procedure intopten;
var f:file;
    TT:TTREC;
    TT_:TTT;
    i:integer;
    p,
    it1,it2:boolean;                    {budou hraci 1,2 v TOPTEN?}
begin
assign(f,'topten.34');
{$I-}reset(f,1);{$I+}
if IOResult=0 then
 begin
  blockread(f,TT,10*sizeof(TTT));
  close(f);
 end else
 begin
  for i:=1 to 10 do
   begin
    TT[i].jmeno:='';
    TT[i].skore:=0;
   end;
 end;
{vyberu kdo pujde do TT}
it1:=false;it2:=false;
if skore[1]>skore[2] then
 if skore[2]>TT[10].skore then
  begin
   it1:=true;
   it2:=true;
  end
 else
 if skore[1]>TT[10].skore then
  begin
   it1:=true;
  end
 else
else;
if skore[1]<skore[2] then
 if skore[1]>TT[10].skore then
  begin
   it1:=true;
   it2:=true;
  end
 else
 if skore[2]>TT[10].skore then
  begin
   it2:=true;
  end
 else
else;
if skore[1]=skore[2] then
 if skore[1]>TT[10].skore then
  it1:=true;                  {maly fixl, ale co se da delat...}

if usedAI[1] then it1:=false; {kdyz byli pocitac nebo Advice, tak je neberu}
if usedAI[2] then it2:=false;

{dam je do TT jako 11 a 12 prvek}
TT[11].skore:=0;
TT[12].skore:=0;
if it1 then
 begin
  writeln('Gratuluji, hraci 1, umistil ses mezi deseti nejlepsimi!');
  write('Zadej sve jmeno:');
  readln(TT[11].jmeno);
  TT[11].skore:=skore[1];
 end;
if it2 then
 begin
  writeln('Gratuluji, hraci 2, umistil ses mezi deseti nejlepsimi!');
  write('Zadej sve jmeno:');
  readln(TT[12].jmeno);
  TT[12].skore:=skore[2];
 end;

{bubblesort na 10 prvku staci}
repeat
p:=true;
for i:=1 to 11 do
 if TT[i].skore<TT[i+1].skore then
  begin
   TT_:=TT[i];
   TT[i]:=TT[i+1];
   TT[i+1]:=TT_;
   p:=false;
  end;
until p;

{ale zapisu jen 10}
rewrite(f,1);
blockwrite(f,TT,10*sizeof(TTT));
close(f);
end;

procedure clrtopten;
var f:file;
    TT:TTREC;
    i:integer;
begin
assign(f,'topten.34');
for i:=1 to 10 do
 begin
  TT[i].jmeno:='';
  TT[i].skore:=0;
 end;
rewrite(f,1);
blockwrite(f,TT,10*sizeof(TTT));
close(f);
end;

procedure advice;                       {vyber a proved tah}
var a,b,d:integer;
begin
 usedai[onturn]:=true;
 AIchoose(a,b,d);
 place2(a,b,d);
end;

procedure disptopten;                   {vypis TOPTEN}
var f:file;
    TT:TTREC;
    i:integer;
begin
assign(f,'topten.34');
reset(f,1);
blockread(f,TT,10*sizeof(TTT));
close(f);
writeln;
writeln('Deset nejlepsich hracu:');
writeln;
for i:=1 to 10 do
 writeln(i:3,'':3,TT[i].jmeno:40,TT[i].skore:5);
end;

procedure run_normal;
var key:char;
    pass,               {propusteni cekacim cyklem}
    lclik,              {emulace l tlacitka}
    rclik:boolean;      {emulace r tlacitka}
    gd,i,gm:integer;
begin
 lclik:=false;rclik:=false;
 repeat write('Strana site(N):');readln(N);until N in [2..NN];
 gd:=0;
 onturn:=1;
 for i:=1 to 2 do skore[i]:=0;
 initgraph(gd,gm,'');
 initfield;
 repeat
  if lclick or lclik then place;
  disp;
  if finished then break;
  repeat until not(rclick or lclick or keypressed); {cekej na vstupni klid}
  repeat
   lclik:=false;rclik:=false;pass:=false;           {klavesnicovy vstup}
   key:=#0;while keypressed do key:=readkey;
   if key<>#0 then pass:=true;
  until rclick or lclick or pass;
  if key=#75 then setmouse(mx-STEP,my);             {emulace mysi}
  if key=#77 then setmouse(mx+STEP,my);
  if key=#72 then setmouse(mx,my-STEP);
  if key=#80 then setmouse(mx,my+STEP);
  if key=#32 then lclik:=true;
  if key=#13 then rclik:=true;
  if key in ['q','Q'] then break;                   {konec}
  if rclik or rclick then advice;                   {advice}
 until 2+2=5;
 closegraph;
end;

procedure run_againstai;
var key:char;
    pass,               {propusteni cekacim cyklem}
    lclik,              {emulace l tlacitka}
    rclik:boolean;      {emulace r tlacitka}
    gd,gm,i:integer;
begin
 lclik:=false;rclik:=false;
 repeat write('Strana site(N):');readln(N);until N in [2..NN];
 gd:=0;
 onturn:=1;
 for i:=1 to 2 do skore[i]:=0;
 initgraph(gd,gm,'');
 initfield;
 repeat
  if onturn=2 then advice
  else if lclick or lclik then place;
  disp;
  if finished then break;
  repeat until not(rclick or lclick or keypressed); {cekej na vstupni klid}
  repeat
   lclik:=false;rclik:=false;pass:=false;           {klavesnicovy vstup}
   key:=#0;while keypressed do key:=readkey;
   if key<>#0 then pass:=true;
  until rclick or lclick or pass or (onturn=2);
  if key=#75 then setmouse(mx-STEP,my);             {emulace mysi}
  if key=#77 then setmouse(mx+STEP,my);
  if key=#72 then setmouse(mx,my-STEP);
  if key=#80 then setmouse(mx,my+STEP);
  if key=#32 then lclik:=true;
  if key=#13 then rclik:=true;
  if key in ['q','Q'] then break;                   {konec}
  if rclik or rclick then advice;                   {advice}
 until 2+2=5;
 closegraph;
end;

procedure run_demo;
var key:char;
    gd,gm,i:integer;
begin
 repeat write('Strana site(N):');readln(N);until N in [2..NN];
 gd:=0;
 onturn:=1;
 for i:=1 to 2 do skore[i]:=0;
 initgraph(gd,gm,'');
 initfield;
 repeat
  advice;
  disp;
  if finished then break;
  key:=#0;while keypressed do key:=readkey;
  if demo then delay(ddelay);
  if (key='+')and(ddelay<1000)then inc(ddelay,100); {zmena delaye pro demo}
  if (key='-')and(ddelay>50)then  dec(ddelay,100);
  if key in ['q','Q'] then break;                   {konec}
 until 2+2=5;
 readkey;while keypressed do readkey;
 closegraph;
end;


var c:char;

begin
 init;

 repeat
 repeat
 clrscr;
 writeln('Safety matches');
 writeln('Zvol:');
 writeln('  1)Hra clovek proti cloveku');
 writeln('  2)Hra clovek proti pocitaci');
 writeln('  3)Hra pocitac proti pocitaci - demo');
 writeln('  4)Zobrazit topten');
 writeln('  5)Vynulovat topten');
 writeln('  6)Konec');
 readln(c);
 until c in ['1'..'6'];
 if c='2' then againstAI:=true else againstAI:=false;
 if c='3' then demo:=true else demo:=false;
 case c of
  '1':run_normal;
  '2':run_againstai;
  '3':run_demo;
  '4':begin
       clrscr;
       disptopten;
       readkey;while keypressed do readkey;
      end;
  '5':clrtopten;
 end;
 if c in ['1','2'] then {vyhodnoceni}
  if finished then
   begin
    writeln('Skore hrace c.1: ',skore[1]);
    writeln('Skore hrace c.2: ',skore[2]);
    if usedai[1] then writeln('Za hrace 1 hral pocitac!!!');
    if usedai[2] then writeln('Za hrace 2 hral pocitac!!!');
    if skore[1]>skore[2] then writeln('Vyhral hrac cislo 1') else
    if skore[1]<skore[2] then writeln('Vyhral hrac cislo 2') else
     writeln('Remiza!');
    readkey;while keypressed do readkey;
    intopten;
    clrscr;
    disptopten;
    readkey;while keypressed do readkey;
   end;
 until c='6';
 clrscr;
end.